/*
 * 个人中心常用工具
 */

using System;
using System.Web;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Http;
using Microsoft.Extensions.Logging;
using Microsoft.Extensions.Options;
using MySystem.Models;
using Library;
using LitJson;
using MySystemLib;

namespace MySystem.Areas.Admin.Controllers
{
    [Area("Admin")]
    [Route("Admin/[controller]/[action]")]
    public class UserCenterIconListController : BaseController
    {
        public UserCenterIconListController(IHttpContextAccessor accessor, ILogger<BaseController> logger, IOptions<Setting> setting) : base(accessor, logger, setting)
        {
            OtherMySqlConn.connstr = ConfigurationManager.AppSettings["SqlConnStr"].ToString();
        }

        #region 个人中心常用工具列表

        /// <summary>
        /// 根据条件查询个人中心常用工具列表
        /// </summary>
        /// <returns></returns>
        public IActionResult Index(UserCenterIconList data, string right)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;

            return View();
        }

        #endregion

        #region 根据条件查询个人中心常用工具列表

        /// <summary>
        /// 个人中心常用工具列表
        /// </summary>
        /// <returns></returns>
        public JsonResult IndexData(UserCenterIconList data, int page = 1, int limit = 30)
        {

            Dictionary<string, string> Fields = new Dictionary<string, string>();

            Fields.Add("Title", "1"); //标题
            Fields.Add("Url", "1"); //跳转地址


            string condition = " and Status>-1";


            Dictionary<string, object> obj = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).IndexData("UserCenterIconList", Fields, "Id desc", "0", page, limit, condition);
            List<Dictionary<string, object>> diclist = obj["data"] as List<Dictionary<string, object>>;
            foreach (Dictionary<string, object> dic in diclist)
            {

            }
            return Json(obj);
        }

        #endregion

        #region 增加个人中心常用工具

        /// <summary>
        /// 增加或修改个人中心常用工具信息
        /// </summary>
        /// <returns></returns>
        public IActionResult Add(string right)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;


            return View();
        }

        #endregion

        #region 增加个人中心常用工具

        /// <summary>
        /// 增加或修改个人中心常用工具信息
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public string Add(UserCenterIconList data)
        {
            Dictionary<string, object> Fields = new Dictionary<string, object>();

            Fields.Add("Icon", data.Icon); //图标
            Fields.Add("Title", data.Title); //标题
            Fields.Add("Url", data.Url); //跳转地址

            Fields.Add("SeoTitle", data.SeoTitle);
            Fields.Add("SeoKeyword", data.SeoKeyword);
            Fields.Add("SeoDescription", data.SeoDescription);
            int Id = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Add("UserCenterIconList", Fields, 0);
            AddSysLog(data.Id.ToString(), "UserCenterIconList", "add");
            db.SaveChanges();

            SetRedis();

            return "success";
        }

        #endregion

        #region 修改个人中心常用工具

        /// <summary>
        /// 增加或修改个人中心常用工具信息
        /// </summary>
        /// <returns></returns>
        public IActionResult Edit(string right, int Id = 0)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;


            UserCenterIconList editData = db.UserCenterIconList.FirstOrDefault(m => m.Id == Id) ?? new UserCenterIconList();
            ViewBag.data = editData;
            return View();
        }

        #endregion

        #region 修改个人中心常用工具

        /// <summary>
        /// 增加或修改个人中心常用工具信息
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public string Edit(UserCenterIconList data)
        {
            Dictionary<string, object> Fields = new Dictionary<string, object>();

            Fields.Add("Icon", data.Icon); //图标
            Fields.Add("Title", data.Title); //标题
            Fields.Add("Url", data.Url); //跳转地址

            Fields.Add("SeoTitle", data.SeoTitle);
            Fields.Add("SeoKeyword", data.SeoKeyword);
            Fields.Add("SeoDescription", data.SeoDescription);
            new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("UserCenterIconList", Fields, data.Id);
            AddSysLog(data.Id.ToString(), "UserCenterIconList", "update");
            db.SaveChanges();

            SetRedis();

            return "success";
        }

        #endregion

        #region 删除个人中心常用工具信息

        /// <summary>
        /// 删除个人中心常用工具信息
        /// </summary>
        /// <returns></returns>
        public string Delete(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id, "UserCenterIconList", "del");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", -1);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("UserCenterIconList", Fields, id);
            }
            db.SaveChanges();

            SetRedis();

            return "success";
        }

        #endregion

        #region 开启

        /// <summary>
        /// 开启
        /// </summary>
        /// <returns></returns>
        public string Open(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id, "UserCenterIconList", "open");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", 1);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("UserCenterIconList", Fields, id);
            }
            db.SaveChanges();
            return "success";
        }

        #endregion

        #region 关闭

        /// <summary>
        /// 关闭
        /// </summary>
        /// <returns></returns>
        public string Close(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id, "UserCenterIconList", "close");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", 0);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("UserCenterIconList", Fields, id);
            }
            db.SaveChanges();
            return "success";
        }

        #endregion

        #region 排序
        /// <summary>
        /// 排序
        /// </summary>
        /// <param name="Id"></param>
        public string Sort(int Id, int Sort)
        {
            new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Sort("UserCenterIconList", Sort, Id);

            AddSysLog(Id.ToString(), "UserCenterIconList", "sort");

            SetRedis();
            return "success";
        }
        #endregion

        #region 导入数据
        /// <summary>
        /// 导入数据
        /// </summary>
        /// <param name="ExcelData"></param>
        public string Import(string ExcelData)
        {
            ExcelData = HttpUtility.UrlDecode(ExcelData);
            JsonData list = JsonMapper.ToObject(ExcelData);
            for (int i = 1; i < list.Count; i++)
            {
                JsonData dr = list[i];

                db.UserCenterIconList.Add(new UserCenterIconList()
                {
                    CreateDate = DateTime.Now,
                    UpdateDate = DateTime.Now,

                });
                db.SaveChanges();
            }
            AddSysLog("0", "UserCenterIconList", "Import");
            return "success";
        }
        #endregion

        #region 导出Excel

        /// <summary>
        /// 导出Excel
        /// </summary>
        /// <returns></returns>
        public JsonResult ExportExcel(UserCenterIconList data)
        {
            Dictionary<string, string> Fields = new Dictionary<string, string>();
            Fields.Add("Title", "1"); //标题
            Fields.Add("Url", "1"); //跳转地址


            string condition = " and Status>-1";


            Dictionary<string, object> obj = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).IndexData("UserCenterIconList", Fields, "Id desc", "0", 1, 20000, condition, "", false);
            List<Dictionary<string, object>> diclist = obj["data"] as List<Dictionary<string, object>>;
            foreach (Dictionary<string, object> dic in diclist)
            {

            }

            Dictionary<string, object> result = new Dictionary<string, object>();
            result.Add("Status", "1");
            result.Add("Info", "Excel报表-" + DateTime.Now.ToString("yyyy-MM-ddTHH:mm:ss") + ".xlsx");
            result.Add("Obj", diclist);
            Dictionary<string, object> ReturnFields = new Dictionary<string, object>();

            result.Add("Fields", ReturnFields);
            AddSysLog("0", "UserCenterIconList", "ExportExcel");
            return Json(result);
        }

        #endregion



        #region 设置缓存

        private void SetRedis()
        {
            List<UserCenterIconList> query = db.UserCenterIconList.Where(m => m.Status > -1).OrderByDescending(m => m.Sort).ThenByDescending(m => m.Id).ToList();
            RedisDbconn.Instance.Clear("UserCenterIconList");
            RedisDbconn.Instance.AddList("UserCenterIconList", query.ToArray());
        }

        #endregion

    }
}
